            

function [S1,lamda1]=fourShrinkT1(sdcorrObsPL,SampleData,choosesn)


            % Start shrinkage method
            % ---------------------------------------------------------------------
            % Sample Covariance Matrix
            zip=sdcorrObsPL;
            zi=mean(zip,2);
            zi=zi(:,ones(SampleData,1));
            zjp=zip';
            zj=mean(zjp,1);
            zj=zj(ones(SampleData,1),:);
            samplec=((zip-zi)*(zjp-zj))/(SampleData-1);

            % Correlation Matrix From Sample Covariance Matrix
            Cij=samplec;
            varSamC=diag(samplec);
            Cii=varSamC(:,ones(choosesn,1));
            Cjj=Cii';
            CorrMat=Cij./sqrt(Cii.*Cjj);

            % Average Correlation Between Network Nodes
            avgCorr=(sum(sum(CorrMat))) / (choosesn*((choosesn)-1));

            % Variance of Sample Cij
            vij=((SampleData-1)/SampleData)*Cij;
            for count1=1:SampleData
                vijp(:,:,count1)=(zip(:,count1)-zi(:,count1))*(zjp(count1,:)-zj(count1,:));
            end

            for count2=1:SampleData
                vcij(:,:,count2)=(vijp(:,:,count2)-vij).^2;
            end
            VarCij=(SampleData/((SampleData-1)^3)).*sum(vcij,3);

            % Variance of Sample Cii
            for count3=1:SampleData
                vcii(:,:,count3)=((diag(diag(vijp(:,:,count3))))-(diag(diag(vij)))).^2;
            end
            VarCii=(SampleData/((SampleData-1)^3)).*sum(vcii,3);

            % Diagonal, unit variance (Target A)
            T1ijond=diag(diag(ones(length(Cij))));
            T1ijoffd=diag(diag(zeros(length(Cij))));
            T1ij=T1ijond+T1ijoffd;

            % Finding Lamda
            numer1=(sum(sum(VarCij-diag(diag(VarCij)))))+(sum(sum(VarCii)));
            denor1=(sum(sum((Cij-diag(diag(Cij))).^2)))+(sum(sum(diag(diag(Cii))-diag(diag(ones(length(Cii))))).^2));
            lamdaconstant1=numer1/denor1;
            lamda1=max(0,min(1,lamdaconstant1));

            % Shrinkage Covariance Matrix
            S1=(lamda1*T1ij) + (1-lamda1)*(samplec);
            
            % -------------------------------------------------------------
            % End shrinkage method
            
end