clear variables;
clc;
clf(figure(1),'reset');


SD=[3 4 5 6];
for observationno=1:length(SD)
    
    totrmsenoc=0; totrmsetruec=0; totrmsesh1c=0; totrmsesh2=0;
    
    for experimentno=1:1

        % Set sensor locations
        AllLocSensor=[0,0;0,10;0,20;10,0;10,10;10,20;20,0;20,10;20,20];
        SN=length(AllLocSensor);

        % Initializing parameters
        startime=1;      % Movement starting time in seconds
        endtime=10;      % Movement ending time in seconds
        dt=0.5;          % Discretisation time step
        posxsn1=[]; velxsn1=[]; posysn1=[]; velysn1=[]; 
        posxsn2=[]; velxsn2=[]; posysn2=[]; velysn2=[]; 
        posxsn3=[]; velxsn3=[]; posysn3=[]; velysn3=[]; 
        posxsn4=[]; velxsn4=[]; posysn4=[]; velysn4=[]; 
        posxsn5=[]; velxsn5=[]; posysn5=[]; velysn5=[]; 
        posxsn6=[]; velxsn6=[]; posysn6=[]; velysn6=[]; 
        posxsn7=[]; velxsn7=[]; posysn7=[]; velysn7=[]; 
        posxsn8=[]; velxsn8=[]; posysn8=[]; velysn8=[]; 
        posxsn9=[]; velxsn9=[]; posysn9=[]; velysn9=[]; 
        x_sn1=[AllLocSensor(1,1), 0.02, AllLocSensor(1,2), 0.02]';
        x_sn2=[AllLocSensor(2,1), 0.02, AllLocSensor(2,2), 0.02]';
        x_sn3=[AllLocSensor(3,1), 0.02, AllLocSensor(3,2), 0.02]';
        x_sn4=[AllLocSensor(4,1), 0.02, AllLocSensor(4,2), 0.02]';
        x_sn5=[AllLocSensor(5,1), 0.02, AllLocSensor(5,2), 0.02]';
        x_sn6=[AllLocSensor(6,1), 0.02, AllLocSensor(6,2), 0.02]';
        x_sn7=[AllLocSensor(7,1), 0.02, AllLocSensor(7,2), 0.02]';
        x_sn8=[AllLocSensor(8,1), 0.02, AllLocSensor(8,2), 0.02]';
        x_sn9=[AllLocSensor(9,1), 0.02, AllLocSensor(9,2), 0.02]';

        alpha=0.6;                          % = 1/tau, where tau is the average maneuvering time of the target 
        x_k=[1.3, 0.02, 0, 2.5, 0.02, 0]';  % Initized state vector, it has 3 components: [position; velocity; acceleration] for each coordinate
        posx=[]; velx=[]; accelx=[];
        posy=[]; vely=[]; accely=[];
        eta=3; ln=@log; gama=10/ln(10);  
        x_k_all=[];
        dcorr=40;
        choosesn=9;                 % No. of sensor nodes choosen to perform localisation
        N=500;                      % Generate Number of particles
        N_thresh=N/1;               % Threshold for performing the resampling step
        x_ksize=size(x_k,1);        % dimension of the state vector

        % Assigned variance to all sensor nodes
        varysn=randi([1 4],1,SN);
        
        % Defined set of acceleration levels and its transition probabilities      
        Accset=[0.5 0.0; 0.0 0.8]';         % Acceleration levels
        NoofAccset=2;                       % Number of acceleration levels    
        ProbAccset=[0.80 0.02];          	% Probability of each level (How often the level being used)

        % Transition probabilities from one level to another level
        Samelvl=0.5; 
        Difflvl=(1-Samelvl)/(NoofAccset-1);
        for i=1:NoofAccset
            for j=1:NoofAccset       
                if i==j, 
                    Probtrans(i,j)=Samelvl; 
                else
                    Probtrans(i,j)=Difflvl; 
                end
            end    
        end

        % Initialized commands 
        AccLvl=EventSearch(NoofAccset,ProbAccset);

        iter1=1;
        for k=startime:dt:endtime  
            % GENERATE SENSOR MOVEMENTS
            % Motion model for all sensor nodes
            Asn=[1 dt;0 1];
            Bsn=[dt^2/2; dt];
            ASN1=blkdiag(Asn,Asn);
            BSN1=blkdiag(Bsn,Bsn);

            % Moving trajectory sensor node 1
            u_sn1=[0.10 0.10]'; 
            x_sn1=ASN1*x_sn1 + BSN1*u_sn1; 
            posxsn1=[posxsn1; x_sn1(1)];        
            posysn1=[posysn1; x_sn1(3)];   
            LocSn1=[posxsn1 posysn1];

            % Moving trajectory sensor node 2
            if k<4,                 u_sn2=[0.05 -0.05]';         
               elseif k>=4 & k<7,   u_sn2=[0.12  0.0]';
               elseif k>=7,         u_sn2=[0.0   0.15]';
            end
            x_sn2=ASN1*x_sn2 + BSN1*u_sn2;
            posxsn2=[posxsn2; x_sn2(1)];        
            posysn2=[posysn2; x_sn2(3)];
            LocSn2=[posxsn2 posysn2];

            % Moving trajectory sensor node 3
            if k<4,                 u_sn3=[0.05 -0.05]';       
               elseif k>=4 & k<7,   u_sn3=[0.10  0.0]';
               elseif k>=7,         u_sn3=[0.15 -0.15]';
            end
            x_sn3=ASN1*x_sn3 + BSN1*u_sn3;
            posxsn3=[posxsn3; x_sn3(1)];        
            posysn3=[posysn3; x_sn3(3)];
            LocSn3=[posxsn3 posysn3];

            % Moving trajectory sensor node 4
            if k<4,                 u_sn4=[-0.05 0.05]';      
               elseif k>=4,         u_sn4=[0.05  0.05]';
            end
            x_sn4=ASN1*x_sn4 + BSN1*u_sn4;
            posxsn4=[posxsn4; x_sn4(1)];        
            posysn4=[posysn4; x_sn4(3)];    
            LocSn4=[posxsn4 posysn4];

            % Moving trajectory sensor node 5
            if k<4,                 u_sn5=[-0.05 -0.05]';      
               elseif k>=4,         u_sn5=[0.15   0.15]';
            end
            x_sn5=ASN1*x_sn5 + BSN1*u_sn5;
            posxsn5=[posxsn5; x_sn5(1)];        
            posysn5=[posysn5; x_sn5(3)];
            LocSn5=[posxsn5 posysn5];

            % Moving trajectory sensor node 6
            if k<4,                 u_sn6=[-0.05 -0.05]';      
               elseif k>=4,         u_sn6=[0.15  -0.05]';
            end
            x_sn6=ASN1*x_sn6 + BSN1*u_sn6;
            posxsn6=[posxsn6; x_sn6(1)];        
            posysn6=[posysn6; x_sn6(3)];
            LocSn6=[posxsn6 posysn6];

            % Moving trajectory sensor node 7
            if k<6,                 u_sn7=[-0.05 0.05]';      
               elseif k>=6,         u_sn7=[0.05  0.15]';
            end
            x_sn7=ASN1*x_sn7 + BSN1*u_sn7;
            posxsn7=[posxsn7; x_sn7(1)];        
            posysn7=[posysn7; x_sn7(3)];
            LocSn7=[posxsn7 posysn7];

            % Moving trajectory sensor node 8
            if k<4,                 u_sn8=[-0.05 -0.05]';      
               elseif k>=4,         u_sn8=[-0.05  0.15]';
            end
            x_sn8=ASN1*x_sn8 + BSN1*u_sn8;
            posxsn8=[posxsn8; x_sn8(1)];        
            posysn8=[posysn8; x_sn8(3)];
            LocSn8=[posxsn8 posysn8];

            % Moving trajectory sensor node 9
            u_sn9=[-0.05 -0.05]';  
            x_sn9=ASN1*x_sn9 + BSN1*u_sn9;
            posxsn9=[posxsn9; x_sn9(1)];        
            posysn9=[posysn9; x_sn9(3)];
            LocSn9=[posxsn9 posysn9];

            % Store all Location of sensor nodes at every time
            movLocationSensor=[LocSn1(iter1,:);LocSn2(iter1,:);LocSn3(iter1,:);LocSn4(iter1,:);LocSn5(iter1,:);
                            LocSn6(iter1,:);LocSn7(iter1,:);LocSn8(iter1,:);LocSn9(iter1,:);];
                        
            LocationSensor=movLocationSensor; 
            
            % GENERATE TARGET TRAJECTORY
            % Initialized transition matrix
            A1=[1 dt dt^2/2; 0 1 dt; 0 0 alpha];
            A=blkdiag(A1,A1);
            
            % Initilaized command matrix
            B1=[dt^2/2; dt; 0];
            B=blkdiag(B1,B1);
            
            % Setting input command
            if k<2,                 u_k=[0.5  0.0]';
               elseif k>=2 & k<4,   u_k=[0.0  0.8]';
               elseif k>=4 & k<6,   u_k=[0.5  0.0]';
               elseif k>=6 & k<8,   u_k=[0.5  0.0]';
               elseif k>=8,         u_k=[0.5, 0.0]';
            end
            
            % Initialized noise coefficient matrix
            C1=[dt^2/2; dt; 1];
            C=blkdiag(C1,C1); 

            % Process noise
            w_k=sqrt(2)*randn(2,1);

            % Motion model 
            x_k = A*x_k + B*u_k; % + C*w_k;

            posx=[posx; x_k(1)];        % store value of position x
            velx=[velx; x_k(2)];        % store value of velocity x
            accelx=[accelx; x_k(3)];    % store value of acceleration x    
            posy=[posy; x_k(4)];        % store value of position y
            vely=[vely; x_k(5)];        % store value of velocity y
            accely=[accely; x_k(6)];    % store value of acceleration y    
            x_k_all(:,iter1)=x_k;       % store all state vector values
            
            % Stored all position of moving target
            PositionTarget=[posx posy];
            
            % GENERATE SENSOR MEASUREMENTS
            % Distance between all sensors and moving target at every time step
            distance=sqrt((posx(iter1,1)-LocationSensor(:,1)).^2 + (posy(iter1,1)-LocationSensor(:,2)).^2);

            % Actual RSS signal between all sensors & moving targets  
            ActualPL=10*eta*log10(distance);    

            % Picked only 3 sensor nodes with highest RSS signal
            [sortActualPL indxSN]=sort(ActualPL,'ascend');
            threActualPL=sortActualPL(1:choosesn,1);
            threindxz=indxSN(1:choosesn,1);
            threLocSensor=LocationSensor(threindxz,:);   

            % Distance between 3 picked sensor nodes
            thredtsn=pdist(threLocSensor,'euclidean');  
            
            % Variance of 3 picked sensor nodes
            threvariansn=varysn(:,threindxz);
            
            % CORRELATIONS MODEL TO GENERATE CORRELATED SENSOR MEASUREMENTS 
            % Spatial correlation
            threpij=exp(-thredtsn/dcorr);
            for SensorNo=1:length(thredtsn)
                threspatialcorr(SensorNo+1)=threpij(SensorNo);
            end  
            
            % Spatial variances
            spatthrevariansn=varysn(:,threindxz);   
            
            % Diagonal entries of spatial covariance matrix
            covarian=diag(varysn(:,threindxz));
            
            % Off-diagonal entries of spatial covariance matrix
            var1=2; var2=0; var3=1;
            for SensorNo=1:choosesn 
                for MSN=SensorNo:choosesn-1    
                    covarian(1+var2:var3, MSN+1:MSN+1)=diag(threspatialcorr(:,var1)*sqrt(spatthrevariansn(1,SensorNo))*sqrt(spatthrevariansn(1,MSN+1)));
                    covarian(MSN+1:MSN+1, 1+var2:var3)=diag(threspatialcorr(:,var1)*sqrt(spatthrevariansn(1,SensorNo))*sqrt(spatthrevariansn(1,MSN+1)));          
                    var1=var1+1;
                end
                var2=var2+1;
                var3=var3+1;
            end

            % Doing Cholesky Decomposition M=LL' or M=UU'
            decompC=chol(covarian);
            
            % GENERATE CORRELATED RSS AT SENSOR NODES
            % Generate number of sample data
            iter2=1;
            for SampleData=1:SD(observationno)
                % Noise as Shadowing Effect
                Shadow=randn(choosesn,1);
                v_k=sqrt(threvariansn(:)).*Shadow;   % Measurement noise 

                % Generating Correlated Noise
                tpcorrNoise=Shadow'*decompC;
                corrv_k=tpcorrNoise';

                % Measurement Model
                ObsPL=threActualPL + v_k;
                corrObsPL=threActualPL + corrv_k;

                % Sample data of measurements
                sdObsPL(:,iter2)=ObsPL;
                sdcorrObsPL(:,iter2)=corrObsPL;

                iter2=iter2+1;
            end

            % Stored all Generated RSS Signal
            mObsPL(:,iter1)=mean(sdObsPL,2);  
            mcorrObsPL(:,iter1)=mean(sdcorrObsPL,2); 

            % SHRINKAGE TECHNIQUE
            [S1,lamda1]=ShrinkT1(sdcorrObsPL,SampleData,choosesn);
            [S6,lamda6]=ShrinkT6(sdcorrObsPL,SampleData,choosesn);
          
            lamda1(iter1,:)=lamda1;
            lamda6(iter1,:)=lamda6;
            
            % Stored covariance matrices
            TrueC(:,:,iter1)=covarian;
            mthreindxz(:,iter1)=threindxz;
            ShrinkC(:,:,iter1)=S1;
            Sh2rinkC(:,:,iter1)=S6;
       
            for i=1:N
                % Distributes particles around the starting vector state
                a=sqrt(1)*randn(6,1);
                x_kinit(:,i)=x_k + sqrt(1)*a;
                corrx_kinit(:,i)=x_k + sqrt(1)*a;
                shx_kinit(:,i)=x_k + sqrt(1)*a;
                sh2x_kinit(:,i)=x_k + sqrt(1)*a;
   
                % Initial weights for each of the particles
                weight(i)=1;
                corrweight(i)=1;
                shweight(i)=1;
                sh2weight(i)=1;
            end
            
            % Take RSS measurement vector
            z=mObsPL(:,iter1);
            zcorr=mcorrObsPL(:,iter1);
            
            % Index of 3 highest sensor nodes
            indxz=mthreindxz(:,iter1);
  
            % Location Sensor
            LocSensor=LocationSensor(indxz,:);
            corrLocationSensor=LocationSensor(indxz,:);
            shLocationSensor=LocationSensor(indxz,:);
            sh2LocationSensor=LocationSensor(indxz,:);
            
            % Choose uk from a set of acceleration lvls  
            temp1=Probtrans(AccLvl,:); 
            NewAccLvl=EventSearch(NoofAccset,temp1); 
            estu_k=Accset(NewAccLvl,:)';  
            
            % TRACKING WITH PARTICLE FILTER
            for i=1:N 
                % Particle motion model (Update the new state of all particles)
                x_kupdate(:,i)=A*x_kinit(:,i) + B*estu_k + C*w_k;
                corrx_kupdate(:,i)=A*corrx_kinit(:,i) + B*estu_k + C*w_k;
                shx_kupdate(:,i)=A*shx_kinit(:,i) + B*estu_k + C*w_k;
                sh2x_kupdate(:,i)=A*sh2x_kinit(:,i) + B*estu_k + C*w_k;
        
                % Find position state based on the updating state vector
                pos_update=[x_kupdate(1,i) x_kupdate(4,i)];
                corrpos_update=[corrx_kupdate(1,i) corrx_kupdate(4,i)];
                shpos_update=[shx_kupdate(1,i) shx_kupdate(4,i)];
                sh2pos_update=[sh2x_kupdate(1,i) sh2x_kupdate(4,i)];
          
                % Distance between all Particles & Sensor Nodes
                distEst=sqrt((pos_update(1)-LocSensor(:,1)).^2 + (pos_update(2)-LocSensor(:,2)).^2);
                corrdistEst=sqrt((corrpos_update(1)-corrLocationSensor(:,1)).^2 + (corrpos_update(2)-corrLocationSensor(:,2)).^2);
                shdistEst=sqrt((shpos_update(1)-shLocationSensor(:,1)).^2 + (shpos_update(2)-shLocationSensor(:,2)).^2);
                sh2distEst=sqrt((sh2pos_update(1)-sh2LocationSensor(:,1)).^2 + (sh2pos_update(2)-sh2LocationSensor(:,2)).^2);
        
                % Particle measurement model (Updated measurement between all Particles & Sensor Nodes)
                zEstimated=10*eta*log10(distEst);
                zcorrEstimated=10*eta*log10(corrdistEst);
                zshEstimated=10*eta*log10(shdistEst);
                zsh2Estimated=10*eta*log10(sh2distEst);
             
                % Difference between true measurement and estimated measurement
                inovations=(z-zEstimated); 
                corrinovations=(zcorr-zcorrEstimated);  
                shinovations=(zcorr-zshEstimated); 
                sh2inovations=(zcorr-zsh2Estimated);
          
                % Covariance matrix
                R=1; 
                inv_R=inv(R);
                corrR=TrueC(:,:,iter1); 
                inv_corrR=inv(corrR);
                shR=ShrinkC(:,:,iter1); 
                inv_shR=inv(shR);
                sh2R=Sh2rinkC(:,:,iter1); 
                inv_sh2R=inv(sh2R);

                % Probability of estimated measurement is actually equal to the true measurement
                liklhd = exp(-0.5*inovations'*inv_R*inovations) + 1e-99;
                corrliklhd = exp(-0.5*corrinovations'*inv_corrR*corrinovations) + 1e-99;
                shliklhd = exp(-0.5*shinovations'*inv_shR*shinovations) + 1e-99;
                sh2liklhd = exp(-0.5*sh2inovations'*inv_sh2R*sh2inovations) + 1e-99;
     
                % Updated Weights of Particles
                weight(i) = weight(i)*liklhd;
                corrweight(i) = corrweight(i)*corrliklhd;
                shweight(i) = shweight(i)*shliklhd;
                sh2weight(i) = sh2weight(i)*sh2liklhd;
                
            end
            
            % Normalised all weights to form a probability distribution, adjust distribution to have a common mean
            weight=weight./sum(weight); 
            corrweight=corrweight./sum(corrweight); 
            shweight=shweight./sum(shweight); 
            sh2weight=sh2weight./sum(sh2weight);

            sumxkupdate=0; 
            corrsumxkupdate=0;
            shsumxkupdate=0;
            sh2sumxkupdate=0;
            
            for i=1:N
                % Remapped each updated weight into each particles
                weightx_k=x_kupdate(:,i)*weight(i);
                corrweightx_k=corrx_kupdate(:,i)*corrweight(i);
                shweightx_k=shx_kupdate(:,i)*shweight(i);
                sh2weightx_k=sh2x_kupdate(:,i)*sh2weight(i);

                % Sum all the remapped particles
                sumxkupdate=sumxkupdate+weightx_k;
                corrsumxkupdate=corrsumxkupdate+corrweightx_k;
                shsumxkupdate=shsumxkupdate+shweightx_k;
                sh2sumxkupdate=sh2sumxkupdate+sh2weightx_k;
            end
            
            % The predicted state vector for every time step
            x_kestimate(:,iter1)=sumxkupdate;
            corrx_kestimate(:,iter1)=corrsumxkupdate;
            shx_kestimate(:,iter1)=shsumxkupdate;
            sh2x_kestimate(:,iter1)=sh2sumxkupdate;

            % Resampling
            % Calculate the efficient number of samples
            N_eff = 1/sum(weight(:).*weight(:));    
            if N_eff < N_thresh                                     % Perform resampling if less than threshold
                [indx,corrindx,shindx,sh2indx]=MovresampleRes1(weight,corrweight,shweight,sh2weight);    % Residual resampling        
                x_kinit= x_kupdate(:,indx);                         % Update vector state
                weight=ones(1,N);                                   % After resampling, all particles have same important weight 
                corrx_kinit= corrx_kupdate(:,corrindx); 
                corrweight=ones(1,N);
                shx_kinit= shx_kupdate(:,shindx); 
                shweight=ones(1,N);
                sh2x_kinit= sh2x_kupdate(:,sh2indx); 
                sh2weight=ones(1,N);
            else
                x_kinit=x_kupdate;
                corrx_kinit=corrx_kupdate;
                shx_kinit=shx_kupdate;
                sh2x_kinit=sh2x_kupdate;
            end
            
             iter1=iter1+1;   
        end

        % Storing estimated state vector
        % Stored estimated position of target at every time step
        PositionEst=[x_kestimate(1,:)' x_kestimate(4,:)'];
        corrPositionEst=[corrx_kestimate(1,:)' corrx_kestimate(4,:)'];
        shPositionEst=[shx_kestimate(1,:)' shx_kestimate(4,:)'];
        sh2PositionEst=[sh2x_kestimate(1,:)' sh2x_kestimate(4,:)'];
    
        % Root Mean Square Error (RMSE) for each experiments
        rmsenoc=(1/length(startime:dt:endtime))*sum(sqrt(sum((PositionTarget-PositionEst).^2,2)));
        rmsetruec=(1/length(startime:dt:endtime))*sum(sqrt(sum((PositionTarget-corrPositionEst).^2,2)));
        rmsesh1c=(1/length(startime:dt:endtime))*sum(sqrt(sum((PositionTarget-shPositionEst).^2,2)));
        rmsesh2=(1/length(startime:dt:endtime))*sum(sqrt(sum((PositionTarget-sh2PositionEst).^2,2)));

        % Total RMSE for all experiments
        totrmsenoc=totrmsenoc+rmsenoc;
        totrmsetruec=totrmsetruec+rmsetruec;
        totrmsesh1c=totrmsesh1c+rmsesh1c;
        totrmsesh2=totrmsesh2+rmsesh2;
    end

    % RMSE
    RMSE_Without_Cov(observationno,1)=totrmsenoc/(experimentno*observationno);
    RMSE_With_True_Cov(observationno,1)=totrmsetruec/(experimentno*observationno);
    RMSE_With_ShrinkT1_Cov(observationno,1)=totrmsesh1c/(experimentno*observationno);
    RMSE_With_ShrinkT2_Cov(observationno,1)=totrmsesh2/(experimentno*observationno);  
end


% Plotting position of sensor nodes and target trajectory
iter3=1;
for k=startime:dt:endtime  
    figure(1); clf;
    plot(posx(iter3,1),posy(iter3,1),'--bo','MarkerFaceColor','b'); hold on;
    plot(posxsn1(iter3,1),posysn1(iter3,1),'--kd','MarkerFaceColor','k'); hold on;
    plot(posxsn2(iter3,1),posysn2(iter3,1),'--kd','MarkerFaceColor','k'); hold on;
    plot(posxsn3(iter3,1),posysn3(iter3,1),'--kd','MarkerFaceColor','k'); hold on;
    plot(posxsn4(iter3,1),posysn4(iter3,1),'--kd','MarkerFaceColor','k'); hold on;
    plot(posxsn5(iter3,1),posysn5(iter3,1),'--kd','MarkerFaceColor','k'); hold on;
    plot(posxsn6(iter3,1),posysn6(iter3,1),'--kd','MarkerFaceColor','k'); hold on;
    plot(posxsn7(iter3,1),posysn7(iter3,1),'--kd','MarkerFaceColor','k'); hold on;
    plot(posxsn8(iter3,1),posysn8(iter3,1),'--kd','MarkerFaceColor','k'); hold on;
    plot(posxsn9(iter3,1),posysn9(iter3,1),'--kd','MarkerFaceColor','k'); hold on;   
    xlim([-5, 25]); 
    ylim([-5, 25]);
    xlabel('x coordinate, [m]');
    ylabel('y coordinate, [m]');
    iter3=iter3+1;
    pause(0.2);
end

% Plotting RMSE
figure(2); clf;
withoutC=RMSE_Without_Cov;
TrueCov=RMSE_With_True_Cov;
ShT1C=RMSE_With_ShrinkT1_Cov;
ShT2C=RMSE_With_ShrinkT2_Cov; 
plot(SD(1:end),withoutC,'-ko','MarkerSize',8,'lineWidth',1.2); hold on 
plot(SD(1:end),TrueCov,'-bs','MarkerSize',8,'lineWidth',1.2); hold on 
plot(SD(1:end),ShT1C,'-g^','MarkerSize',8,'lineWidth',1.2); hold on
plot(SD(1:end),ShT2C,'-rv','MarkerSize',8,'lineWidth',1.2); hold on 
xlabel('No. of Observations [P]');          
ylabel('Position RMSE [m]');
grid on
legend('C = I','C = True Covariance','C = Shrinkage T1','C = Shrinkage T2','Location','Northeast');

